// SpacePartitionProxy.h: interface for the SpacePartitionProxy class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPACEPARTITIONPROXY_H__53C6CE62_F053_4D4D_B371_5FD1BE1CD2E1__INCLUDED_)
#define AFX_SPACEPARTITIONPROXY_H__53C6CE62_F053_4D4D_B371_5FD1BE1CD2E1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "..\AfxStreamProxy.h"
#include "..\..\..\IM1Decoders\AFX\SpacePartition\SPart.h"
//#include "..\..\..\IM1Decoders\AFX\FootPrint\FPBuilding.h"
#include "Nodes.h"

class SpacePartitionProxy : public AfxStreamProxy
{
public:
	SpacePartitionProxy(SpacePartition* spacepartition);
	virtual ~SpacePartitionProxy();

	// virtual functions
	virtual BOOL Render(OpenGLVisualRenderer* pRenderer, DWORD dwTime);
	virtual void RenderDescription(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

	BOOL RenderBSP(OpenGLVisualRenderer* pRenderer, DWORD dwTime);
	BOOL RenderCellPortal(OpenGLVisualRenderer* pRenderer, DWORD dwTime);
	BOOL RenderPVS(OpenGLVisualRenderer* pRenderer, DWORD dwTime);
	BOOL RenderHDesc(OpenGLVisualRenderer* pRenderer, DWORD dwTime);
	BOOL RenderWSS(OpenGLVisualRenderer* pRenderer, DWORD dwTime);

	BOOL RenderHDescNode(HDescNode* pNode);
	BOOL RenderHDescSphere(HDescNode* pNode);

	virtual BOOL  RenderFromStream(MediaStream* poStream, int id, DWORD dwTime);
	virtual BOOL  RenderFromBuffer(SFString *buffer, int id);
	virtual BOOL  Select(OpenGLVisualRenderer* pRenderer, DWORD dwTime, unsigned int& depth);

	virtual void  SetupDecoderData(BitWrapperProxy *pParent);
	void SetupDecoderData(BitWrapper *poBitWrapper, void *wsDec);

	inline void SetSpacePartition (SPart* spart) { m_pSpacePartition=spart; };
	inline SPart* GetSpacePartition() { return m_pSpacePartition; };

	inline SpacePartition * GetSpacePartitionNode() const
	{ return (SpacePartition *) GetMediaObject(); }


protected:
	bool  m_bInit;
    DWORD m_lastTime;
	SPart* m_pSpacePartition;
	std::list<Switch*> m_DisplayList;
	bool bWssAdded;
};

#endif // !defined(AFX_SPACEPARTITIONPROXY_H__53C6CE62_F053_4D4D_B371_5FD1BE1CD2E1__INCLUDED_)
