// CPPartition.h: interface for the CPPartition class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CPPARTITION_H__7BA76FB4_1D25_4634_BE26_2D96D542236C__INCLUDED_)
#define AFX_CPPARTITION_H__7BA76FB4_1D25_4634_BE26_2D96D542236C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <list>



enum CP_STATE { CP_UNKNOWN=0, CP_BUILT };

class CPCell
{
public:
	CPCell(void) : m_nID(-1), m_xcenter(0.0), m_ycenter(0.0), m_zcenter(0.0), m_dx(0.0), m_dy(0.0), m_dz(0.0), m_bitarray(NULL), m_State(CP_UNKNOWN) { m_listCellIDs.clear(); };
public:
	~CPCell(void) { /*if (m_bitarray!=NULL) free(m_bitarray); m_listCellIDs.clear();*/ };

	float Xmin(void) { return (m_xcenter-m_dx/2); };
	float Ymin(void) { return (m_ycenter-m_dy/2); };

	bool IsInsideCell(float x, float y, float z);
	

public:
	int		m_nID;
	float	m_xcenter;
	float	m_ycenter;
	float	m_zcenter;
	float	m_dx;
	float	m_dy;
	float	m_dz;
	char*	m_bitarray;

	std::list<int>	m_listCellIDs;
	int		m_State;
};



class CPPartition
{
public:
	CPPartition(void);
public:
	~CPPartition(void);

	std::list<int> GetVisibleCPCells(CPCell* pCell);
	CPCell* GetCurrentCell(float x, float y, float z);

	void AddCell(CPCell* pCell);


public:
	int					m_nCellCount;
	std::list<CPCell*>	m_Cells;

//	std::set<CPCell*, lt_Cell>	m_SetCells;

	CPCell*			m_pCurrentCell;
};

#endif // !defined(AFX_CPPARTITION_H__7BA76FB4_1D25_4634_BE26_2D96D542236C__INCLUDED_)
