// HDescTree.cpp: implementation of the HDescTree class.
//
//////////////////////////////////////////////////////////////////////
#include "HDescTree.h"
#include <math.h>
#include "float.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HDescNode::HDescNode()
{

}

HDescNode::HDescNode(float fGcX, float fGcY, float fGcZ, float fMetricError, int s4Radius)
:m_fGcX(fGcX),
m_fGcY(fGcY),
m_fGcZ(fGcZ),
m_fMetricError(fMetricError),
m_radius(s4Radius),
m_nbMissingChildren(0),
m_pParent(NULL),
m_pBrother(NULL)
{
	m_Children.clear();
}

HDescNode::~HDescNode()
{
	m_Children.clear();
}


HDescTree::HDescTree()
{
	m_pRoot = NULL;
}

HDescTree::~HDescTree()
{
	m_SortedNodes.clear();
	if (m_pRoot != NULL) delete(m_pRoot);
}

void HDescTree::AddRoot()
{
	if (NULL == m_pRoot) {
		m_pRoot= new HDescNode(0.0f, 0.0f, 0.0f, FLT_MAX);
		m_pRoot->SetIndex(-1);
		m_pRoot->SetLevel(-1);
	}
}

void HDescTree::AddNode(HDescNode* pNode)
{
	m_SortedNodes.insert(std::make_pair(pNode, pNode->m_index));
}

HDescNode* HDescTree::GetNode(int index)
{
	SORTED_NODES::iterator it;

	HDescNode* pNode = NULL;
//	pNode = new HDescNode(0.0f, 0.0f, 0.0f, FLT_MAX);
//	pNode->SetIndex(index);
//	it = m_SortedNodes.find(pNode);

	for (it=m_SortedNodes.begin(); it!=m_SortedNodes.end(); it++)
	{
		std::pair<HDescNode*, int> pPair = *it;
		if (pPair.second == index)
		{
			pNode = pPair.first;
			break;
		}
	}

	return pNode;
/*	delete pNode;

	if (it == m_SortedNodes.end()) return NULL;
	else return (*it).first;
*/}
