#include "PvsCell.h"
#include <math.h>

PvsCell::PvsCell(void)
{
	m_State = CELL_STATE_UNKNOWN;
	m_nID = -1;
	m_pvs = NULL;				// pvs array
	m_pObjID = NULL;			// array of object IDs

}

PvsCell::~PvsCell(void)
{
	if (m_pvs != NULL) free(m_pvs);
	if (m_pObjID != NULL) delete(m_pObjID);
}

PvsCellRegular::PvsCellRegular(void)
{
}

PvsCellRegular::~PvsCellRegular(void)
{
}

PvsCellIrregular::PvsCellIrregular(void)
{
}

PvsCellIrregular::~PvsCellIrregular(void)
{
}

bool PvsCellIrregular::IsInside(float x, float y)
{
	bool ret=false;

	// TODO: add test with bounding box first
//	ret = m_bbox.IsIn(px,py); // on teste sur la bbox d'abord.
//	if (ret)
	{
		float dx[3];
		float dy[3];
		float mx[3];
		float my[3];
		int oldSign=0;
		int newSign=0;
		float det=0;
	
		// TODO: this is done only for triangles, 
		// should be extended for any polygon
		for (unsigned int i=0; i<3;i++)
		{
			unsigned int ii = (i+1)%3;
			dx[i]= m_x[ii]- m_x[i];
			dy[i]= m_y[ii]- m_y[i];
			mx[i]= x - m_x[i];
			my[i]= y - m_y[i];
			det  = dx[i] * my[i] - dy[i] * mx[i];
			if (fabs(det)>(1e-10f))	//!< Valeur positive (>0) min d'un FT
			{
				newSign=(det>0)?1:-1;
			}
			else
			{
				newSign=0;
			}
			//! Maintenant voir quel est le signe.
			if (oldSign==0)
			{
				oldSign=newSign;
			}
			else if (oldSign!=0 && newSign!=oldSign)
			{
				break;		// deux signes diffrents.
			}
			else
			{
				;			// rien  faire.
			}
		}	//end for.

		if (oldSign==0 || newSign!=oldSign)
		{
			ret=false;
		}
		else
		{
			ret=true;
		}

	}// end if in bbox
	return ret;
}
