#pragma once

//#include "Utility.h"
//#include "PredefinedTypes/PredefinedCollections.h"
#include <list>

enum { CELL_STATE_UNKNOWN=0, CELL_STATE_DECODED };

class PvsCell
{
public:
	PvsCell(void);
public:
	~PvsCell(void);

	void SetState(int state) { m_State = state; };
	int GetState(void) { return m_State; };
	std::list<int>* GetIDs(void) { return m_pObjID; };


public:
	int				m_State;
	int				m_nID;
	char*			m_pvs;			// pvs array
	std::list<int>*	m_pObjID;		// array of object IDs
};


class PvsCellRegular : public PvsCell
{
public:
	PvsCellRegular(void);
public:
	~PvsCellRegular(void);

public:
	int		m_i;
	int		m_j;
};


class PvsCellIrregular : public PvsCell
{
public:
	PvsCellIrregular(void);
public:
	~PvsCellIrregular(void);

	bool IsInside(float x, float y);

public:
	// indexed face set
	float	m_x[3];
	float	m_y[3];
};
