#pragma once

#include <list>
#include <vector>

#include "../../../../core/ztypes.h"

//#include "Utility.h"
//#include "Collections/IDHashTable.h"
//#include "PredefinedTypes/PredefinedCollections.h"
#include "PvsCell.h"

//#include "Scenegraph/FieldsTypes/MFTypes/MFVec3f.h"

class PvsPartition
{
public:
	PvsPartition(void);
public:
	~PvsPartition(void);

	virtual void AddPvsCell(PvsCell* pCell);
	virtual PvsCell* GetPvsCell(float xVP, float yVP, float zVP);

	int FillObjIDs(PvsCell* pCell);
	std::list<int>* GetObjIDs(PvsCell* pCell);


public:	// ANNE TODO: turn private
	int		m_nObjCount;
	int		m_nPvsCount;
	float	m_zmin;
	float	m_zmax;
	int		m_IsRegular;
	int		m_IsCompressed;

	int							m_IDSelected;
	std::list<int>*				m_pObjID;
	//IDHashTable*				m_pPVSArray;
	std::list<PvsPartition*>	m_Children;

	bool		bComposed;
	PvsCell*	m_CurrentCell;
};


class PvsPartitionRegular : public PvsPartition
{
public:
	PvsPartitionRegular(void);
public:
	~PvsPartitionRegular(void);

	void AddPvsCell(PvsCell* pCell);
	PvsCell* GetPvsCell(float xVP, float yVP, float zVP);

public:
	float			m_xmin;
	float			m_xmax;
	float			m_ymin;
	float			m_ymax;
	float			m_dx;
	float			m_dy;
//	IDHashTable*	m_HashCells;	// cells are ordered by ID
	PvsCell**		m_CellsByID;
	int				m_nCells;
};


class PvsPartitionIrregular : public PvsPartition
{
public:
	PvsPartitionIrregular(void);
public:
	~PvsPartitionIrregular(void);

	void AddPvsCell(PvsCell* pCell);
	PvsCell* GetPvsCell(float xVP, float yVP, float zVP);
	void SetIfsCoords(const std::vector<Vec3f>* pCoords) { m_pIfsCoords = pCoords; };
	void SetIfsIndices(const std::vector<int>* pIndices) { m_pIfsIndices = pIndices; };
	void BuildCells(void);



public:
	// indexedfaceset
	std::vector<PvsCell*>			m_ArrayOfCells;
	// TODO: could be ordered by X,Y for faster detection
	
	const std::vector<Vec3f>*	m_pIfsCoords;
	const std::vector<int>*		m_pIfsIndices;

};

