// SPart.h: interface for the SPart class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPART_H__A008126B_656C_4805_94C4_6CF395E44C5F__INCLUDED_)
#define AFX_SPART_H__A008126B_656C_4805_94C4_6CF395E44C5F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "../../../Core/MediaObj.h"
#include "./BSP/bsptree.h"
#include "./CellPortal/cppartition.h"
#include "./PVS/pvspartition.h"
#include "./HDesc/hdesctree.h"
#include "./WSS/wsspartition.h"

// Space Partition
class SPart  
{
public:
	SPart();
	virtual ~SPart();

	inline MediaObject* GetMediaObject() const { return m_pNode; };
	inline void SetMediaObject ( MediaObject* mo) { m_pNode=mo; };

public:
	BSPTree*		m_BSPTree;
	CPPartition*	m_CPPartition;
	PvsPartition*	m_PVSPart;
	HDescTree*		m_HDescTree;
	WssPartition*	m_WSSPart;

public:
	int				m_SPtype;
	MediaObject*	m_pNode;


};

#endif // !defined(AFX_SPART_H__A008126B_656C_4805_94C4_6CF395E44C5F__INCLUDED_)
