// SpacePartDecoderLib.h: interface for the SpacePartDecoderLib class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPACEPARTDECODERLIB_H__B49BB2C4_3104_4260_9806_20285008A7B2__INCLUDED_)
#define AFX_SPACEPARTDECODERLIB_H__B49BB2C4_3104_4260_9806_20285008A7B2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SPart.h"
#include "defs.h"
#include "bitstream.h"
#include "..\AFX.h"

class SpacePartDecoderLib  
{
public:
	SpacePartDecoderLib();
	virtual ~SpacePartDecoderLib();


	inline SetSPart (SPart* spart) { m_pSPart=spart; };

	BOOL Setup (AFXExtDescriptor *pSpecificInfo);

	BOOL DecodeFromBuffer (LPBYTE pInput, int nInputLength);
	BOOL DecodeSpacePartitionStream (LPBYTE pInput, int nInputLength);

private:
	BOOL DecodeSpecificInfo(mbitstream* bs);
	BOOL DecodeSpacePartitionMessage(mbitstream* bs);

	BOOL DecodeBSPMessage(mbitstream* bs);
	BOOL DecodeCellPortalMessage(mbitstream* bs);
	BOOL DecodePVSMessage(mbitstream* bs);
	BOOL DecodeHDescMessage(mbitstream* bs);
	BOOL DecodeWSSMessage(mbitstream* bs);


protected:
	SPart*	m_pSPart;
	SpacePartDecoderSpecificInfo* m_pDSI;
};

#endif // !defined(AFX_SPACEPARTDECODERLIB_H__B49BB2C4_3104_4260_9806_20285008A7B2__INCLUDED_)
