// WssPartition.cpp: implementation of the WssPartition class.
//
//////////////////////////////////////////////////////////////////////

#include "WssPartition.h"
#include <math.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


std::list<int> WssVolume::GetVisibleFaces(void)
{
	if (m_State == VSTATE_DECODED)
		return m_VisibleFaces;
	
	int nBytes = m_wssSizeInBytes;
	int iObj=0;
	for (int iByte=0; iByte<m_wssSizeInBytes; iByte++) 
	{
		unsigned char Byte = (unsigned char) m_wssArray[iByte];
		for (int iBit=0; iBit<8; iBit++) 
		{
			unsigned char flag = (unsigned char)pow((double)2, (int)iBit);
			if (flag & Byte) {
				m_VisibleFaces.push_back(iObj);
			}
			else {
				// skip
			}
			iObj++;
		}
	}
//	delete(pCell->m_bitarray); pCell->m_bitarray=NULL;

	m_State = VSTATE_DECODED;
	return m_VisibleFaces;
}


WssPartition::WssPartition(void)
{
	m_nVolumes = 0;
	m_nFaces = 0;
	m_CurrentVolume = NULL;
}

WssPartition::~WssPartition(void)
{
	m_Volumes.clear();
	
}

WssVolume* WssPartition::GetVolume(float x, float y, float z)
{
	WssVolume* pVolumeOUT = NULL;

	std::list<WssVolume*>::iterator itvolume;
	for (itvolume=m_Volumes.begin(); itvolume!=m_Volumes.end(); itvolume++)
	{
		WssVolume* pVolume = *itvolume;

		if (x < (pVolume->m_centerX - pVolume->m_dX/2)) continue;
		if (x > (pVolume->m_centerX + pVolume->m_dX/2)) continue;
		if (y < (pVolume->m_centerY - pVolume->m_dY/2)) continue;
		if (y > (pVolume->m_centerY + pVolume->m_dY/2)) continue;
		if (z < (pVolume->m_centerZ - pVolume->m_dZ/2)) continue;
		if (z > (pVolume->m_centerZ + pVolume->m_dZ/2)) continue;

		pVolumeOUT = pVolume;
		break;
	}

	m_CurrentVolume = pVolumeOUT;
	return pVolumeOUT;
}
