// WssPartition.h: interface for the WssPartition class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WSSPARTITION_H__0723306E_7FB1_4C0A_8CEE_CE8996E9C78D__INCLUDED_)
#define AFX_WSSPARTITION_H__0723306E_7FB1_4C0A_8CEE_CE8996E9C78D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <list>
enum { VSTATE_UNKNOWN=0, VSTATE_DECODED };


class WssVolume
{
public:
	WssVolume(void) : m_centerX(0), m_centerY(0), m_centerZ(0), m_dX(0), m_dY(0), m_dZ(0), m_State(VSTATE_UNKNOWN) {};
public:
	~WssVolume(void) {};

	std::list<int> GetVisibleFaces(void);

public:
	int	m_nID;
	float m_centerX;
	float m_centerY;
	float m_centerZ;
	float m_dX;
	float m_dY;
	float m_dZ;

	char*			m_wssArray;
	int				m_wssSizeInBytes;
	std::list<int>	m_VisibleFaces;
	int				m_State;
};


class WssPartition
{
public:
	WssPartition(void);
public:
	~WssPartition(void);

public:
	void AddVolume(WssVolume* pVolume) { m_Volumes.push_back(pVolume); };
	WssVolume* GetVolume(float x, float y, float z);

public:
	int m_nVolumes;
	int m_nFaces;

	WssVolume* m_CurrentVolume;
	std::list<WssVolume*> m_Volumes;
};

#endif // !defined(AFX_WSSPARTITION_H__0723306E_7FB1_4C0A_8CEE_CE8996E9C78D__INCLUDED_)
